/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rubenlaguna;

import java.awt.Color;
import java.awt.Point;
import org.netbeans.api.visual.action.ActionFactory;
import org.netbeans.api.visual.action.ConnectProvider;
import org.netbeans.api.visual.action.ConnectorState;
import org.netbeans.api.visual.action.SelectProvider;
import org.netbeans.api.visual.anchor.AnchorFactory;
import org.netbeans.api.visual.anchor.AnchorShape;
import org.netbeans.api.visual.border.BorderFactory;
import org.netbeans.api.visual.graph.GraphScene;
import org.netbeans.api.visual.widget.ConnectionWidget;
import org.netbeans.api.visual.widget.LabelWidget;
import org.netbeans.api.visual.widget.LayerWidget;
import org.netbeans.api.visual.widget.Scene;
import org.netbeans.api.visual.widget.Widget;

/**
 *
 * @author ECERULM
 */
class GraphSceneImpl extends GraphScene.StringGraph {

    private LayerWidget mainLayer;
    private LayerWidget interactionLayer;
    private LayerWidget connectionLayer;

    public GraphSceneImpl() {
        mainLayer = new LayerWidget(this);
        addChild(mainLayer);
        interactionLayer = new LayerWidget(this);
        addChild(interactionLayer);
        connectionLayer = new LayerWidget(this);
        addChild(connectionLayer);

        getActions().addAction(ActionFactory.createSelectAction(new SelectProvider() {

            public boolean isAimingAllowed(Widget arg0, Point arg1, boolean arg2) {
                return false;
            }

            public boolean isSelectionAllowed(Widget arg0, Point arg1, boolean arg2) {
                return true;
            }

            public void select(Widget arg0, Point arg1, boolean arg2) {
                Widget w = GraphSceneImpl.this.addNode("aaaa" + arg1.toString());
                w.setPreferredLocation(arg0.convertLocalToScene(arg1));
            }
        }));
    }

    @Override
    protected Widget attachNodeWidget(String arg0) {
        LabelWidget w = new LabelWidget(this, arg0);
        w.getActions().addAction(ActionFactory.createMoveAction());
        w.setBorder(BorderFactory.createRoundedBorder(10, 10, Color.getHSBColor(50, 50, 155), Color.yellow));
        w.getActions().addAction(ActionFactory.createExtendedConnectAction(connectionLayer, new ConnectProvider() {

            public boolean isSourceWidget(Widget arg0) {
                return true;
            }

            public ConnectorState isTargetWidget(Widget sourceWidget, Widget targetWidget) {
                //return true;
                return sourceWidget != targetWidget && targetWidget instanceof LabelWidget ? ConnectorState.ACCEPT : ConnectorState.REJECT;
            }

            public boolean hasCustomTargetWidgetResolver(Scene arg0) {
                return false;
            }

            public Widget resolveTargetWidget(Scene arg0, Point arg1) {
                return null;
            }

            public void createConnection(Widget sourceWidget, Widget targetWidget) {
                Widget edgeWidget = GraphSceneImpl.this.addEdge(sourceWidget.toString() + targetWidget.toString());

//                ConnectionWidget connection = new ConnectionWidget(GraphSceneImpl.this);
//                connection.setTargetAnchorShape(AnchorShape.TRIANGLE_FILLED);
//                connection.setSourceAnchor(AnchorFactory.createRectangularAnchor(sourceWidget));
//                connection.setTargetAnchor(AnchorFactory.createRectangularAnchor(targetWidget));
//                connectionLayer.addChild(connection);
            }
        }));
        w.getActions().addAction(ActionFactory.createAlignWithMoveAction(mainLayer, interactionLayer, null));
        mainLayer.addChild(w);
        return w;
    }

    @Override
    protected Widget attachEdgeWidget(String arg0) {
        ConnectionWidget connection = new ConnectionWidget(GraphSceneImpl.this);
        connection.setTargetAnchorShape(AnchorShape.TRIANGLE_FILLED);
        //connection.setSourceAnchor(AnchorFactory.createRectangularAnchor(sourceWidget));
        //connection.setTargetAnchor(AnchorFactory.createRectangularAnchor(targetWidget));
        connectionLayer.addChild(connection);
        return connection;
    }

    @Override
    protected void attachEdgeSourceAnchor(String arg0, String arg1, String arg2) {

    }

    @Override
    protected void attachEdgeTargetAnchor(String arg0, String arg1, String arg2) {
    }
}
